///
/// ProcessorImpl
///
import 'dart:async';
import 'dart:isolate';

abstract class ProcessorImpl {
  Future<bool> start(ProcessorHandler processorHandler);
  Future<T?> runTask<T>(String taskType, dynamic taskData);
  void destroy();
}

class ProcessorTask<T> {
  final int time; //请求的时间
  final Completer<T> completer;
  ProcessorTask(this.completer) : time = DateTime.now().millisecondsSinceEpoch;
}

typedef ProcessorHandle = dynamic Function(ProcessorMessage message);

class ProcessorHandler {
  SendPort? sendPort;
  ProcessorHandle bridgeHandle;
  ProcessorHandle customHandle;
  ProcessorHandler({this.sendPort, required this.bridgeHandle, required this.customHandle});
}

class ProcessorMessage {
  final String type;
  final int id;
  final dynamic data;
  ProcessorMessage(this.type, this.id, this.data);
}
